
;;  Paradigmata Programovani 2B, PRIKLADY
;;  Copyright (C) 2008  Vilem Vychodil, <vilem.vychodil@upol.cz>
;;
;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation; version 2 of the License.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; DEMONSTRACE POUZITI OPERATORU `AMB'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define amb-fail
  (let ((failure #f))
    (lambda args
      (if (null? args)
          failure
          (set! failure (if (procedure? (car args))
                            (car args)
                            (lambda ()
                              (error "AMB: Tree Exhausted"))))))))

(amb-fail #f)

(define-macro amb
  (lambda elems
    (let ((previous-fail (gensym)))
      `(let ((,previous-fail (amb-fail)))
         (call/cc
          (lambda (exit)
            ,@(map (lambda (elem)
                     `(call/cc
                       (lambda (next)
                         (amb-fail
                          (lambda ()
                            (amb-fail ,previous-fail)
                            (next)))
                         (exit ,elem))))
                   elems)
            (,previous-fail)))))))

(define assert
  (lambda (elem)
    (if (not elem)
        (amb))))

;; PROBLEM: BARVENI GRAFU
;;;;;;;;;;;;;;;;;;;;;;;;;

;; opacko ze cviceni: grafy obohatime o informaci o barve v uzlech
(define create-node (lambda (id) (list id 'no-color)))
(define get-neighbors cddr)
(define set-color! (lambda (node color) (set-car! (cdr node) color)))
(define get-color cadr)

(define add-neighbor!
  (lambda (node neighbor)
    (if (not (memq node (get-neighbors neighbor)))
        (begin
          (set-cdr! (cdr node) (cons neighbor (get-neighbors node)))
          (set-cdr! (cdr neighbor) (cons node (get-neighbors neighbor)))))))

(define borders '((cz (sk pl de au))
                  (sk (cz pl au hu uk))
                  (pl (de cz sk uk))
                  (de (cz pl au))
                  (hu (au sk uk))
                  (au (cz sk de))
                  (uk (sk pl hu))))

(for-each
 (lambda (x)
   (set-car! x (create-node (car x))))
 borders)

(define countries (map car borders))
countries

(for-each
 (lambda (c)
   (for-each
    (lambda (n)
      (add-neighbor! (car c) (assoc n countries)))
    (cadr c)))
 borders)

countries

; vlastni barveni (trema barvama by neslo):
(amb-fail #f)
(for-each
 (lambda (country)
   (set-color! country (amb 'red 'green 'blue 'yellow))
   (for-each
    (lambda (neighbor)
      (assert (not (equal? (get-color neighbor)
                           (get-color country)))))
    (get-neighbors country)))
 countries)

countries
